/*8F5Kb84w6wpKN/fG0mLUJlkVNZtzd2UqIklU6zQENBK8vSgK7HacPaySY4b/lI3f*/
package nccloud.bs.ssckm.kmsearch.bp;

import java.util.Calendar;
import java.util.Date;
import java.util.Map;

import nc.bs.framework.common.InvocationInfoProxy;
import nc.jdbc.framework.processor.ColumnProcessor;
import nc.vo.ml.MultiLangContext;
import nc.vo.pub.BusinessException;
import nc.vo.pubapp.pattern.pub.SqlBuilder;
import nc.vo.ssckm.kmauthority.KmAuthorityVO;
import nc.vo.ssckm.kmclassify.KmClassifyVO;
import nc.vo.ssckm.kmknowledge.KmKnowledgeVO;
import nccloud.bs.ssckm.pub.bp.KmPubBP;
import nccloud.framework.web.container.SessionContext;
import nccloud.util.ssckm.pub.Func;

import java.text.ParseException;
import java.text.SimpleDateFormat;

/**
 * ֪ʶ-֪ʶౣ
 *
 * @since 2019418
 * @version 1909
 * @author yangzongc
 */
public class CountFuzzyQueryBP extends KmPubBP {
	public int doProcess(Map<String, Object> parammap) throws BusinessException {
		return process(parammap);
	}

	private int process(Map<String, Object> parammap) throws BusinessException {
		SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
		String pk_group = InvocationInfoProxy.getInstance().getGroupId();
		String pk_user = SessionContext.getInstance().getClientInfo().getUserid();
		String searchcontent = Func.toString(parammap.get("searchcontent"));
		String classify = (String) parammap.get("classify");
		int searchtype = Integer.parseInt(Func.toString(parammap.get("searchtype")));
		//add by guojx ҳǩ  ļ·ʱļ 20220416
		boolean searchAlways = (boolean) parammap.get("searchAlways");
		boolean searchLast = (boolean) parammap.get("searchLast");
		Calendar calendar = Calendar.getInstance();
		String businessDate = ((String)parammap.get("businessDate")).substring(0,10);
		try {
			calendar.setTime(sdf.parse(businessDate));
		} catch (ParseException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		calendar.set(Calendar.DAY_OF_MONTH,1);
		String beginDate = sdf.format(calendar.getTime());
		if (searchcontent == null || "".equals(searchcontent))
			return 0;
		searchcontent = searchcontent.replaceAll("'", "''");
		// ֪ʶֶθòѯ
		String name = KmClassifyVO.NAME;
		if (searchtype == 0 || searchtype == 2) {
			Integer intLangSeq = MultiLangContext.getInstance().getCurrentLangSeq();
			if (intLangSeq != null && intLangSeq.intValue() > 1)
				name = name + String.valueOf(intLangSeq.intValue());
		}
		

		SqlBuilder condition = new SqlBuilder();
		SqlBuilder sql = new SqlBuilder();
		sql.append("select count(1) from ");
		sql.append(KmKnowledgeVO.getDefaultTableName());
		
		//ѯѯ
		if (searchAlways) {
			sql.append(
					" left join (select * from knowledge_record where pk_user = '" + pk_user + "' ) knowledge_record");
			sql.append("  on ssckm_knowledge.pk_knowledge  = knowledge_record.billid");
		}
		
		sql.append(" where ");
		sql.append(KmKnowledgeVO.POSTSTATUS + " = 1 ");
		// add by guojx հײѯ
		boolean searchAll = "*".equals(searchcontent);
		switch (searchtype) {
		case 0:// ȫ
			if (!searchAll) {
				sql.append(" and ");
				condition.append("(" + KmKnowledgeVO.CLASSIFY + " in (select " + KmClassifyVO.PK_CLASSIFY + " from "
						+ KmClassifyVO.getDefaultTableName() + " where " + name + " like '%" + searchcontent + "%')");
				condition.append(" or " + KmKnowledgeVO.KEYWORD + " like '%" + searchcontent + "%'");
				condition.append(" or " + KmKnowledgeVO.TITLE + " like '%" + searchcontent + "%'");
				condition.append(" or " + KmKnowledgeVO.CONTENT + " like '%" + searchcontent + "%')");
			}
			break;
		case 1:// ؼ
			if (!searchAll) {
				sql.append(" and ");
				if(searchLast) {
					condition.append(" order by ts desc ");
					break;
				}
				condition.append(KmKnowledgeVO.KEYWORD + " like '%" + searchcontent + "%'");
			}
			break;
		case 2:// 
			if (!searchAll) {
				sql.append(" and ");
				condition.append(KmKnowledgeVO.CLASSIFY + " in (select " + KmClassifyVO.PK_CLASSIFY + " from "
						+ KmClassifyVO.getDefaultTableName() + " where " + name + " like '%" + searchcontent + "%')");
			}
			break;
		case 3:// 
			if (!searchAll) {
				sql.append(" and ");
				condition.append(KmKnowledgeVO.TITLE + " like '%" + searchcontent + "%'");
			}
			break;
		case 4:// 
			if (!searchAll) {
				sql.append(" and ");
				condition.append(KmKnowledgeVO.CONTENT + " like '%" + searchcontent + "%'");
			}
			break;
		}

		condition.append(" and " + KmKnowledgeVO.PK_KNOWLEDGE + " in (select " + KmAuthorityVO.PK_KNOWLEDGE + " from "
				+ KmAuthorityVO.getDefaultTableName() + " where " + KmAuthorityVO.PK_GROUP + " = '" + pk_group + "')");
		sql.append(condition);
		
		if(classify!=null) {
			sql.append(" and " + KmKnowledgeVO.CLASSIFY +" in (select "+KmClassifyVO.PK_CLASSIFY +" from "+ KmClassifyVO.getDefaultTableName() +" where pk_classify = '"+classify+"')");
		}
		
		if(searchLast) {
			sql.append(" and to_date(substr(ts,1,10),'YYYY-MM-DD') between to_date(substr('"+beginDate+"',1,10),'YYYY-MM-DD') and to_date('"+businessDate+"','YYYY-MM-DD')");
		}

		Object sum = BPDAO.executeQuery(Func.toString(sql), new ColumnProcessor());

		return Integer.parseInt(Func.toString(sum));
	}

}

/* 8F5Kb84w6wpKN/fG0mLUJlkVNZtzd2UqIklU6zQENBK8vSgK7HacPaySY4b/lI3f */