/*XLd8VPHEje7EKJSTPe6+mtwni5KtQCyMkj6WRcTb+fU+DjLL49GXWA+tLITuxuvC*/
package nccloud.bs.ssckm.kmsearch.bp;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.List;
import java.util.Map;

import nc.bs.dao.DAOException;
import nc.bs.framework.common.InvocationInfoProxy;
import nc.bs.sscrp.pub.query.PageInfo;
import nc.jdbc.framework.processor.BeanListProcessor;
import nc.vo.ml.MultiLangContext;
import nc.vo.pubapp.pattern.pub.SqlBuilder;
import nc.vo.ssckm.kmauthority.KmAuthorityVO;
import nc.vo.ssckm.kmclassify.KmClassifyVO;
import nc.vo.ssckm.kmknowledge.KmKnowledgeVO;
import nccloud.bs.ssckm.pub.bp.KmPubBP;
import nccloud.framework.web.container.SessionContext;
import nccloud.util.ssckm.kmmaintain.KmMaintainUtil;
import nccloud.util.ssckm.pub.Func;

/**
 * ֪ʶ-֪ʶౣ
 *
 * @since 2019418
 * @version 1909
 * @author yangzongc
 */
public class SearchFuzzyQueryBP extends KmPubBP {
	public KmKnowledgeVO[] doProcess(Map<String, Object> parammap, PageInfo pageinfo) throws DAOException {
		return process(parammap, pageinfo);
	}

	private KmKnowledgeVO[] process(Map<String, Object> parammap, PageInfo pageinfo) throws DAOException {
		SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
		String pk_group = InvocationInfoProxy.getInstance().getGroupId();
		String pk_user = SessionContext.getInstance().getClientInfo().getUserid();
		String searchcontent = Func.toString(parammap.get("searchcontent"));
		if (searchcontent == null || "".equals(searchcontent))
			return null;
		searchcontent = searchcontent.replaceAll("'", "''");
		int searchtype = Integer.parseInt(Func.toString(parammap.get("searchtype")));
		String classify = (String) parammap.get("classify");
		// add by guojx ҳǩ ļ·ʱļ 20220416
		boolean searchAlways = (boolean) parammap.get("searchAlways");
		boolean searchLast = (boolean) parammap.get("searchLast");
		Calendar calendar = Calendar.getInstance();
		String businessDate = ((String) parammap.get("businessDate")).substring(0, 10);
		try {
			calendar.setTime(sdf.parse(businessDate));
		} catch (ParseException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		calendar.set(Calendar.DAY_OF_MONTH, 1);
		String beginDate = sdf.format(calendar.getTime());
		// ֪ʶֶθòѯ
		String name = KmClassifyVO.NAME;
		if (searchtype == 0 || searchtype == 2) {
			Integer intLangSeq = MultiLangContext.getInstance().getCurrentLangSeq();
			if (intLangSeq != null && intLangSeq.intValue() > 1)
				name = name + String.valueOf(intLangSeq.intValue());
		}

		// ѯsqlƴ
		SqlBuilder condition = new SqlBuilder();
		SqlBuilder sql = new SqlBuilder();
		sql.append("select * from ");
		sql.append(KmKnowledgeVO.getDefaultTableName());
		
		//ѯѯ
		if(searchAlways) {
			sql.append(" left join (select * from knowledge_record where pk_user = '"+pk_user+"' ) knowledge_record");
			sql.append("  on ssckm_knowledge.pk_knowledge  = knowledge_record.billid");
		}
		
		
		
		sql.append(" where ");
		sql.append(KmKnowledgeVO.POSTSTATUS + " = 1 ");
		// add by guojx հײѯ 20220416
		boolean searchAll = "*".equals(searchcontent);
		// ƥѯ
		switch (searchtype) {
		case 0:// ȫ
			if (!searchAll) {
				sql.append(" and ");
				condition.append("(" + KmKnowledgeVO.CLASSIFY + " in (select " + KmClassifyVO.PK_CLASSIFY + " from "
						+ KmClassifyVO.getDefaultTableName() + " where " + name + " like '%" + searchcontent + "%')");
				condition.append(" or " + KmKnowledgeVO.KEYWORD + " like '%" + searchcontent + "%'");
				condition.append(" or " + KmKnowledgeVO.TITLE + " like '%" + searchcontent + "%'");
				condition.append(" or " + KmKnowledgeVO.CONTENT + " like '%" + searchcontent + "%')");
			}
			break;
		case 1:// ؼ
			if (!searchAll) {
				sql.append(" and ");
				condition.append(KmKnowledgeVO.KEYWORD + " like '%" + searchcontent + "%'");
			}
			break;
		case 2:// 
			if (!searchAll) {
				sql.append(" and ");
				condition.append(KmKnowledgeVO.CLASSIFY + " in (select " + KmClassifyVO.PK_CLASSIFY + " from "
						+ KmClassifyVO.getDefaultTableName() + " where " + name + " like '%" + searchcontent + "%')");
			}
			break;
		case 3:// 
			if (!searchAll) {
				sql.append(" and ");
				condition.append(KmKnowledgeVO.TITLE + " like '%" + searchcontent + "%'");
			}
			break;
		case 4:// 
			if (!searchAll) {
				sql.append(" and ");
				condition.append(KmKnowledgeVO.CONTENT + " like '%" + searchcontent + "%'");
			}
			break;
		}

		// ˼Ȩ
		condition.append(" and " + KmKnowledgeVO.PK_KNOWLEDGE + " in (select " + KmAuthorityVO.PK_KNOWLEDGE + " from "
				+ KmAuthorityVO.getDefaultTableName() + " where " + KmAuthorityVO.PK_GROUP + " = '" + pk_group + "')");
		sql.append(condition);
		if(searchLast) {
			sql.append(" and to_date(substr(ts,1,10),'YYYY-MM-DD') between to_date(substr('"+beginDate+"',1,10),'YYYY-MM-DD') and to_date('"+businessDate+"','YYYY-MM-DD')");
		}
		
		if(classify!=null) {
			sql.append(" and " + KmKnowledgeVO.CLASSIFY +" in (select "+KmClassifyVO.PK_CLASSIFY +" from "+ KmClassifyVO.getDefaultTableName() +" where pk_classify = '"+classify+"')");
		}
		String orderInfo = null;
		if(searchAlways) {
			orderInfo = " order by times desc nulls last";
		}else {
			orderInfo = "order by " + KmKnowledgeVO.MODIFYTIME + " desc";
		}

		// ÷ҳ
		String sqlstr = Func.toString(KmMaintainUtil.gePageQrySQL(pageinfo, Func.toString(sql), orderInfo));

		@SuppressWarnings("unchecked")
		List<KmKnowledgeVO> resultVOs = (List<KmKnowledgeVO>) this.BPDAO.executeQuery(sqlstr,
				new BeanListProcessor(KmKnowledgeVO.class));
		if (resultVOs != null && resultVOs.size() > 0) {
			return resultVOs.toArray(new KmKnowledgeVO[resultVOs.size()]);
		}
		return null;
	}

}

/* XLd8VPHEje7EKJSTPe6+mtwni5KtQCyMkj6WRcTb+fU+DjLL49GXWA+tLITuxuvC */